/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	学習管理クラスタイプ１
// 【共通ログ登録・更新パターン】
// ----------------------------------
// 登録項目(1回目の学習開始)
// ・UserID
// ・LOID
// ・study_start_date(学習開始日付)
// ・residanceTime(0固定)
// ・passday(学習開始日付)
// ・study_end_date(学習開始日付)
// ・highScore(0固定)
// ・lowsScore(0固定)
// ・execise_point(0固定)
// ・fullscore(0固定)
// ・Access_cnt(1)
// ・last_access(学習開始日付)
// ----------------------------------
// 更新項目(2回目の学習開始)
// ・Access_cnt(更新前の値 + 1)
// ・last_access(学習開始日付)
// ----------------------------------
// 【共通ログセッション登録パターン】
// ----------------------------------
// 登録項目(毎回登録)
// ・UserID
// ・LOID
// ・SessionID(学習数)
// ・rstudy_start_date(学習開始日付)
// ・residanceTime(0固定)
// ・passday(学習開始日付)
// ・study_end_date(学習開始日付)
// ・highScore(0固定)
// ・lowsScore(0固定)
// ・execise_point(0固定)
// ・fullscore(0固定)
// ----------------------------------
//			変更履歴
// 2004.01.08 新規作成 suzuki
//

package jp.co.ntt.lms.lo;

import java.util.Hashtable;

import jp.co.ntt.lms.Common.status.PropagateControl;
import jp.co.ntt.lms.Common.status.StatusPropagation;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.XMOException;
import jp.co.ntt.lms.xmo.Assignments.AssignmentsClient;
import jp.co.ntt.lms.xmo.Lo.LoClient;
import jp.co.ntt.lms.xmo.util.DebugLog;
import jp.co.ntt.lms.xmo.util.XMODate;

/**
 * 学習管理の共通親クラス
 * 学習開始時にステータスが決定し、学習終了処理のないLOのログ更新処理を実装します。
 *
 */
public class LearnManagerType1
	implements LearnManager, LoPropertyDef
{
	/**
	 * 学習開始処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return Object 学習開始URL
	 * @exception LOException LO固有の例外エラー
	 */
	public final Object startLearn(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
// 学習回数のカウントアップ
		// 学習開始処理を実行します。
		Object returnValue = null;
		String userID = null;
// 学習対象ＬＯのLOID
		String targetLOID = null;

		AssignmentsClient assignmentsClient = null;
		
		try {
			DebugLog.write( getClass(), "startLearn(Hashtable[" + htbParam +"],DataAccess)",DebugLog.ROW);
			// ログ出力処理を実行します。
			startUpdateLog(htbParam, objDataAccess);
			// 開始処理
			returnValue = startLearnAction(htbParam, objDataAccess);
			// =================================================================
			// ユーザID、LOIDの取得
			userID = (String)htbParam.get(USER);
			// 学習対象ＬＯのLOIDを取得
			targetLOID = (String)htbParam.get(TARGETLOID);
			// =================================================================
			// 学習回数のカウントアップ
			assignmentsClient = new AssignmentsClient();
// カウントアップ用に引き渡すIDをマテリアルIDからLOIDに変更します。

// 呼び出すメソッドのI/F変更に伴う修正
			DebugLog.write( getClass()
				, "AssignmentsClient#countupStudyCount("
					+ "\"" + userID +"\""
					+ ", \""+ targetLOID +"\""
					+ ", null)"
				, DebugLog.ROW );
			assignmentsClient.countupStudyCount(userID, targetLOID, null);
		} catch (XMOException e) {
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException(e.getMessage());
		} catch (Exception e) {
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException(e.getMessage());
		}
		return returnValue;
	}

	/**
	 * 学習終了処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return Object NULL
	 * @exception LOException Lo固有の例外エラー
	 */
	public Object endLearn(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		// 学習終了処理を実行します。
		return endLearnAction(htbParam, objDataAccess);
	}
	
	/**
	 * 学習開始時のログ出力処理を実行します。
	 */
	protected void startUpdateLog(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{

		try
		{
			// ユーザIDの取得
			String strUserID = (String)htbParam.get( USER );
			// LOIDの取得
			String strLoID = (String)htbParam.get( LOID );

			LoLogSessionDataAccess objSessionDataAccess = new LoLogSessionDataAccess();
			int intStudyCount = objSessionDataAccess.getStudyCount( strUserID, strLoID ) + 1;
			String strSessionID = intStudyCount + "";

			// 本日日付の取得
			String strNow = XMODate.parseTime( new java.util.Date() );
			LoLogDataAccess objLoLogDataAccess = new LoLogDataAccess();
			// ステータスログクラス取得
			LoLogRecord objRecord = objLoLogDataAccess.getLoLog( strUserID, strLoID );
			if( objRecord == null ) {
				objRecord = new LoLogRecord();
				objRecord.setResidanceTime( "0" );
				objRecord.setHighScore("0");		
				objRecord.setLowScore("0");		
				objRecord.setStudyStartDate( strNow );
				objRecord.setStudyEndDate( strNow );
				objRecord.setPassday( strNow );
				objRecord.setExecisePoint("0");
				objRecord.setFullScore("0");
				objRecord.setUserID( strUserID );
				objRecord.setLoID( strLoID );
				objRecord.setAccessCnt("1");
				objRecord.setLastAccess( strNow );
			}else{
				// アクセス回数設定
				long lngAccessCnt = 0;
				
				// 2回目以降に学習する場合、前回までのアクセス回数に＋１して設定
				lngAccessCnt = new Float( objRecord.getAccessCnt() ).longValue() + 1;
				objRecord.setAccessCnt( lngAccessCnt + "" );
				
				// 最終アクセス日時設定
				objRecord.setLastAccess( strNow );

			}

			// 登録処理
			objLoLogDataAccess.insertUpdate( objRecord, strUserID, strLoID, objDataAccess );
			
			// 参照LOIDリストを取得します
			LoClient objLoClient = new LoClient();
			if(!objLoClient.getListFromRealLOID( strLoID )){
				new LOException("参照LOIDリストの取得失敗しました。");
			}
			String[] strRefList = objLoClient.getRefListResult();
			// 参照リスト分ステータス伝播
			for(int i = 0; i < strRefList.length; i++){
				// ステータス伝搬処理
				StatusPropagation objStatus = new StatusPropagation( strUserID, strRefList[i] );
				PropagateControl.getInstance().addPropagate(objStatus);
			}

			// セッションテーブルの登録レコード生成
			LoLogSessionRecord objSessionData = new LoLogSessionRecord();
			// セッションテーブルのインスタンス化
			objSessionData = new LoLogSessionRecord();
			// セッションレコードにコピー
			objSessionData.setStudyStartDate( strNow );
			objSessionData.setResidanceTime( "0" );
			objSessionData.setPassday( strNow );								
			objSessionData.setStudyEndDate( strNow );							
			objSessionData.setHighScore( objRecord.getHighScore() );
			objSessionData.setLowScore( objRecord.getLowScore() );
			objSessionData.setExecisePoint( objRecord.getExecisePoint() );
			objSessionData.setFullScore( objRecord.getFullScore() );
			objSessionData.setUserID( strUserID );
			objSessionData.setLoID( strLoID );
			objSessionData.setSessionID( strSessionID );

			// セッションテーブル登録処理
			objSessionDataAccess.insert( objSessionData, objDataAccess );

		}
		catch(LOException le)
		{
			throw le;
		}
		catch(Exception e)
		{
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException(e.getMessage());
		}
	}
	
	/**
	 * 学習開始処理を実行します。<br>
	 * 学習回数の回数のカウントアップを行います。
	 */
	protected Object startLearnAction(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		
		return null;
	}
	
	/**
	 * 学習終了処理を実行します。
	 */
	protected Object endLearnAction(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		return null;
	}
	
}
